/*
Sample Sketch for the CL0802-STATION

http://www.microfan.jp/station/cl0802-station
*/

#include <ST7032.h>
#include <MCP23008.h>

ST7032 lcd(PWR3V3) ; // LCDの稼働電圧は3.3V
MCP23008 gpio(4) ; // I2Cアドレス0x24(4)

#define LED1  6
#define LED2  7

void setup()
{
  lcd.begin(16, 2);
  lcd.print("SW Test");

  gpio.begin(MCP23008_CL0802) ; // CL0802_STATION用の初期化
}

void loop()
{
  uint8_t i ;
  char buff[] = "        " ; // 文字LED用の8文字の空白文字列

  // タクトスイッチ0,1の変化はLEDに
  gpio.digitalWrite(LED1, !gpio.digitalRead(0));
  gpio.digitalWrite(LED2, !gpio.digitalRead(1));

  // タクトスイッチ2-5の変化は文字液晶に
  for (i = 2; i < 6; i++) {
    buff[(i - 2) * 2] = gpio.digitalRead(i) ? '_' : '1' + i ;
  }
  
  lcd.setCursor(0, 1) ;
  lcd.print(buff) ;

  delay(100) ;
}
