/*
Sample Sketch for the CL0802-STATION
*/

#include <ST7032.h>
#include <MCP23008.h>

ST7032 lcd(PWR3V3) ; // LCDの稼働電圧は3.3V
MCP23008 gpio(4) ; // I2Cアドレス0x24(4)

#define LED1  6
#define LED2  7

// I/Oエクスパンダの初期化
void initSWandLED()
{
  gpio.begin() ; // デフォルトの初期化

   // タクトスイッチ端子をプルアップ付入力で初期化
  for (uint8_t i = 0; i < 6; i++)
    gpio.pinMode(i, INPUT_PULLUP) ;

  // LED端子を出力で初期化し消灯
  gpio.pinMode(LED1, OUTPUT) ;
  gpio.pinMode(LED2, OUTPUT) ;
  gpio.digitalWrite(LED1, LOW) ;
  gpio.digitalWrite(LED2, LOW ) ;
}

void setup()
{
  lcd.begin(16, 2);
  lcd.print("SW Test");

  initSWandLED() ;
}

void loop()
{
  uint8_t i ;
  char buff[] = "        " ; // 文字LED用の8文字の空白文字列

  // タクトスイッチ0,1の変化はLEDに
  gpio.digitalWrite(LED1, !gpio.digitalRead(0));
  gpio.digitalWrite(LED2, !gpio.digitalRead(1));

  // タクトスイッチ2-5の変化は文字液晶に
  for (i = 2; i < 6; i++) {
    buff[(i - 2) * 2] = gpio.digitalRead(i) ? '_' : '1' + i ;
  }
  
  lcd.setCursor(0, 1) ;
  lcd.print(buff) ;

  delay(100) ;
}
