/*
Sample Sketch for the GL12864-STATION

http://www.microfan.jp/station/gl12864-station
*/

#include <U8g2lib.h>
#include <MCP23008.h>

U8G2_ST7920_128X64_1_HW_SPI u8g2(U8G2_R0, /* CS=*/ 10) ;
MCP23008 gpio(4) ; // I2Cアドレスは0x24(4)

#define BACKLIGHT 7
#define SOUNDER 8 // 接続に合わせて設定

void setup()
{
  u8g2.begin() ;  

  gpio.begin(MCP23008_GL12864) ; // GL12864-STATION用の初期化
  gpio.digitalWrite(BACKLIGHT, HIGH) ; // バックライトを点ける
}

void loop()
{
  u8g2.firstPage();
  do {
    // タクトスイッチ2-5の変化は文字液晶に
    for (uint8_t i = 0; i < 7; i++) {
      if (gpio.digitalRead(i))
        u8g2.drawRFrame(18 * i, 16, 16, 24, 5);
      else
        u8g2.drawRBox(18 * i, 16, 16, 24, 5);
    }
    u8g2.setFont(u8g2_font_ncenB10_tr);
    u8g2.drawStr( 15, 62, "Push Button");
  } while ( u8g2.nextPage() );

  if (~gpio.readPORT() & 0x7F)
    tone(SOUNDER, 400) ;
  else
    noTone(SOUNDER) ;
    
  delay(100) ;
}