/*
Sample Sketch for the OLED-STATION

http://www.microfan.jp/station/oled-station
*/

#include <U8g2lib.h>
#include <MCP23008.h>

U8G2_SH1106_128X64_NONAME_1_HW_I2C u8g2(U8G2_R0) ;
MCP23008 gpio(4) ; // I2Cアドレスは0x24(4)

#define LED1  6
#define LED2  7
#define SOUNDER 8 // 接続に合わせて設定

void setup()
{
  u8g2.begin() ;  

  gpio.begin(MCP23008_OLED) ; // OLED_STATION用の初期化
}

void loop()
{
  u8g2.firstPage();
  do {
    // タクトスイッチ2-5の変化は文字液晶に
    for (uint8_t i = 0; i < 4; i++) {
      if (gpio.digitalRead(i + 2))
        u8g2.drawRFrame(32 * i, 16, 30, 24, 5);
      else
        u8g2.drawRBox(32 * i, 16, 30, 24, 5);
    }
    u8g2.setFont(u8g2_font_ncenB10_tr);
    u8g2.drawStr( 15, 62, "Push Button");
  } while ( u8g2.nextPage() );

  // タクトスイッチ0,1の変化はLEDに
  gpio.digitalWrite(LED1, !gpio.digitalRead(0));
  gpio.digitalWrite(LED2, !gpio.digitalRead(1));

  if (~gpio.readPORT() & 0x3F)
    tone(SOUNDER, 400) ;
  else
    noTone(SOUNDER) ;
    
  delay(100) ;
}
