/*
MCP23008.h

Copyright (c) Kenichi KAKIZAKI. All right reserved.

http://www.microfan.jp/library/mcp23008
*/

#ifndef _MCP23008_H
#define _MCP23008_H

#define MCP23008_ADDRESS 0x20

// registers
#define MCP23008_IODIR 0x00
#define MCP23008_IPOL 0x01
#define MCP23008_GPINTEN 0x02
#define MCP23008_DEFVAL 0x03
#define MCP23008_INTCON 0x04
#define MCP23008_IOCON 0x05
#define MCP23008_GPPU 0x06
#define MCP23008_INTF 0x07
#define MCP23008_INTCAP 0x08
#define MCP23008_GPIO 0x09
#define MCP23008_OLAT 0x0A

#define	MCP23008_DEFAULT	0xFF
#define	MCP23008_CL0802	0x3F
#define	MCP23008_OLED	0x3F
#define	MCP23008_TFT14	0x3F
#define	MCP23008_TFT18	0x3F
#define	MCP23008_GL12864	0x7F

class MCP23008 {
public:
  MCP23008(uint8_t addr) ;
  MCP23008(void) ;

  void begin(uint8_t device) ;
  void begin(void) ;

  void pinMode(uint8_t p, uint8_t d) ;
  void digitalWrite(uint8_t p, uint8_t d) ;
  uint8_t digitalRead(uint8_t p) ;

  uint8_t readPORT(void) ;
  void writePORT(uint8_t) ;
  void writeIODIR(uint8_t) ;
  void writePU(uint8_t) ;

 private:
  uint8_t i2caddr ;
  uint8_t iodir ;
  uint8_t pullup ;
  uint8_t data ;
  uint8_t read_register(uint8_t addr) ;
  void write_register(uint8_t addr, uint8_t data) ;
} ;

#endif
